//+------------------------------------------------------------------+
//|                                               ind for leeway.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property strict
#property indicator_chart_window

#property indicator_buffers 10

extern int N = 12;

extern int HMA_Period = 20;
extern int HMA_PriceType = 0;
extern int HMA_Method = 3;
extern bool NormalizeValues = TRUE;
extern int NormalizeDigitsPlus = 2;
extern int VerticalShift = 0;

input int i_nSignalsToCount = 50;	//    

double g_fSigResult[1];
int g_nTotalSignals = 0;


extern int pips = 1;          //       

//  				
double u[],d[];

//     LeManSignal
double LeManUpBuffer[], LeManDownBuffer[];	

//     HMA
double HMABuffer0[];
double HMABuffer1[];
double HMABuffer2[];
double HMABuffer3[];
double HMABuffer4[];
double HMABuffer5[];

//    ( )
datetime g_dtLastBarTime = 0;

datetime g_dtStartTime = 0;
//--------------------------------------------------------------------

int OnInit()
{
	ArrayResize(g_fSigResult, i_nSignalsToCount);
	ZeroMemory(g_fSigResult);
	g_nTotalSignals = 0;
	
	g_dtLastBarTime = 0;
	
	g_dtStartTime = TimeCurrent();
	
   SetIndexStyle(0, DRAW_ARROW, STYLE_SOLID, 1, clrDeepSkyBlue);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, u);
   SetIndexEmptyValue(0, 0.0);
   
   SetIndexStyle(1, DRAW_ARROW, STYLE_SOLID, 1, clrTomato);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, d);
   SetIndexEmptyValue(1, 0.0);
   
   SetIndexBuffer(2, LeManUpBuffer);
   SetIndexStyle(2, DRAW_NONE);
   
   SetIndexBuffer(3, LeManDownBuffer);
   SetIndexStyle(3, DRAW_NONE);
   
   SetIndexBuffer(4, HMABuffer0);
   SetIndexStyle(4, DRAW_NONE);
   SetIndexBuffer(5, HMABuffer1);
   SetIndexStyle(5, DRAW_NONE);
   SetIndexBuffer(6, HMABuffer2);
   SetIndexStyle(6, DRAW_NONE);
   SetIndexBuffer(7, HMABuffer3);
   SetIndexStyle(7, DRAW_NONE);
   SetIndexBuffer(8, HMABuffer4);
   SetIndexStyle(8, DRAW_NONE);
   SetIndexBuffer(9, HMABuffer5);
   SetIndexStyle(9, DRAW_NONE);

   
   return (INIT_SUCCEEDED);
}

void OnDeinit(const int reason)
{
	ObjectDelete(ChartID(), "Label Signals");
	ObjectDelete(ChartID(), "Label Win");
	ObjectDelete(ChartID(), "Label Lose");
	ObjectDelete(ChartID(), "Label WinRate");
	ObjectDelete(ChartID(), "Label WinValue");
	ObjectDelete(ChartID(), "Label LoseValue");
	ObjectDelete(ChartID(), "Label WinRateValue");
}

//--------------------------------------------------------------------

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]) 
{
	if(prev_calculated == 0)
	{
		ZeroMemory(g_fSigResult);
		g_nTotalSignals = 0;
		g_dtLastBarTime = 0;
	}
	
   double fATR = 0;
   
   int nStartIndex = rates_total - prev_calculated;
   if(nStartIndex > rates_total - 3)
   	nStartIndex = rates_total - 3;
   	
   //     HMA
   int nPeriod1 = (int) MathFloor(HMA_Period / 2);
   int nPeriod2 = (int) MathFloor(MathSqrt(HMA_Period));
  	
   if (HMABuffer0[nStartIndex] > HMABuffer0[nStartIndex + 1]) 
   	CleanPoint(nStartIndex, HMABuffer1, HMABuffer2);
   	
   if (HMABuffer0[nStartIndex] < HMABuffer0[nStartIndex + 1])
   	CleanPoint(nStartIndex, HMABuffer3, HMABuffer4);
   	
   for (int i = nStartIndex; i >= 0; i--)
   	HMABuffer5[i] = 2.0 * iMA(NULL, 0, nPeriod1, 0, HMA_Method, HMA_PriceType, i) - iMA(NULL, 0, HMA_Period, 0, HMA_Method, HMA_PriceType, i);


	for(int i = nStartIndex; i >= 0; i--)
	{
		//   LeManSignal
		{
			double H1 = iHigh(NULL, 0, iHighest(NULL, 0, MODE_HIGH, N, i+1));
			double H2 = iHigh(NULL, 0, iHighest(NULL, 0, MODE_HIGH, N, i+1+N));
      	double H3 = iHigh(NULL, 0, iHighest(NULL, 0, MODE_HIGH, N, i+2));
      	double H4 = iHigh(NULL, 0, iHighest(NULL, 0, MODE_HIGH, N, i+2+N));
      	
      	double L1 = iLow(NULL, 0, iLowest(NULL, 0, MODE_LOW, N, i+1));
      	double L2 = iLow(NULL, 0, iLowest(NULL, 0, MODE_LOW, N, i+1+N));
      	double L3 = iLow(NULL, 0, iLowest(NULL, 0, MODE_LOW, N, i+2));
      	double L4 = iLow(NULL, 0, iLowest(NULL, 0, MODE_LOW, N, i+2+N));

      	LeManUpBuffer[i]   = 0;
      	LeManDownBuffer[i] = 0;

			//                         
			if(H3 <= H4 && H1 > H2) 
				LeManUpBuffer[i] = 1;

			//        
			if(L3 >= L4 && L1 < L2)
				LeManDownBuffer[i] = 1;
		}
		
		//   HMA
		{
			int nDigits = _Digits + NormalizeDigitsPlus;
			
			if (NormalizeValues)
	      	HMABuffer0[i] = NormalizeDouble(iMAOnArray(HMABuffer5, 0, nPeriod2, 0, HMA_Method, i), nDigits) + VerticalShift * Point;
	      else
	      	HMABuffer0[i] = iMAOnArray(HMABuffer5, 0, nPeriod2, 0, HMA_Method, i) + VerticalShift * Point;
	      	
	      HMABuffer1[i] = EMPTY_VALUE;
	      HMABuffer2[i] = EMPTY_VALUE;
	      HMABuffer3[i] = EMPTY_VALUE;
	      HMABuffer4[i] = EMPTY_VALUE;
	      
	      if (HMABuffer0[i] > HMABuffer0[i + 1])
	      	PlotPoint(i, HMABuffer1, HMABuffer2, HMABuffer0);
	      	
	      if (HMABuffer0[i] < HMABuffer0[i + 1])
	      	PlotPoint(i, HMABuffer3, HMABuffer4, HMABuffer0);
		}
		
		//     
		fATR = iATR(_Symbol, _Period, 100, 1);
		
		//      
		if(time[i] > g_dtLastBarTime && time[i] >= g_dtStartTime)
		{
			g_dtLastBarTime = time[i];
		
			u[i] = 0;
			d[i] = 0;
			
			if(LeManDownBuffer[i] > 0 && (HMABuffer1[i+1] != EMPTY_VALUE || HMABuffer2[i+1] != EMPTY_VALUE))
			{
				u[i] = low[i] - fATR;
				
				if(u[i] <= 0)
					u[i] = low[i];
				
				// 
				if(i == 0)
					Alert(_Symbol + ": Signal Buy at " + TimeToString(time[0], TIME_MINUTES));
					
			}
	       
	      if(LeManUpBuffer[i] > 0 && (HMABuffer3[i+1] != EMPTY_VALUE || HMABuffer4[i+1] != EMPTY_VALUE))
	      {
	      	d[i] = high[i] + fATR;
      	
	      	// 
				if(i == 0)
					Alert(_Symbol + ": Signal Sell at " + TimeToString(time[0], TIME_MINUTES));
			}
	
	      //  	
	      if(u[i+1] > 0)
			{
				for(int j = i_nSignalsToCount - 1; j > 0; j--)
					g_fSigResult[j] = g_fSigResult[j-1];
					
				g_fSigResult[0] = close[i+1] - open[i+1];
				
				g_nTotalSignals++;
				
				if(g_nTotalSignals > i_nSignalsToCount)
					g_nTotalSignals = i_nSignalsToCount;
					
			}
		
			if(d[i+1] > 0)
			{		
				for(int j = i_nSignalsToCount - 1; j > 0; j--)
					g_fSigResult[j] = g_fSigResult[j-1];
					
				g_fSigResult[0] = open[i+1] - close[i+1];
				
				g_nTotalSignals++;
				
				if(g_nTotalSignals > i_nSignalsToCount)
					g_nTotalSignals = i_nSignalsToCount;
			}
		}
	}
	
	
	
	//  
	int nWins = 0;
	int nLose  = 0;
	
	for(int i = 0; i < g_nTotalSignals; i++)
	{	
		if(g_fSigResult[i] > 0)
			nWins++;
		else
			nLose++;
	}
	
	double fPercentWin = 0;
	if(g_nTotalSignals > 0)
		fPercentWin = ((double) nWins) / ((double) g_nTotalSignals) * 100;
	
	//  
	long nChartID = ChartID();
	
	if(ObjectFind(nChartID, "Label Signals") == -1)
		LabelCreate(nChartID, "Label Signals", 90, 30, "Signals: 0", 15, clrGreen);

	if(ObjectFind(nChartID, "Label Win") == -1)
		LabelCreate(nChartID, "Label Win", 150, 55, "Win", 12, clrGreen);
		
	if(ObjectFind(nChartID, "Label Lose") == -1)
		LabelCreate(nChartID, "Label Lose", 100, 55, "Lose", 12, clrRed);
		
	if(ObjectFind(nChartID, "Label WinRate") == -1)
		LabelCreate(nChartID, "Label WinRate", 40, 55, "WinRate", 12, clrGreen);
		
	if(ObjectFind(nChartID, "Label WinValue") == -1)
		LabelCreate(nChartID, "Label WinValue", 150, 80, "0", 12, clrGreen);
		
	if(ObjectFind(nChartID, "Label LoseValue") == -1)
		LabelCreate(nChartID, "Label LoseValue", 100, 80, "0", 12, clrRed);
		
	if(ObjectFind(nChartID, "Label WinRateValue") == -1)
		LabelCreate(nChartID, "Label WinRateValue", 40, 80, "0%", 12, clrGreen);
	
	ObjectSetText("Label Signals", "Signals: " + IntegerToString(g_nTotalSignals)); 
	ObjectSetText("Label WinValue", IntegerToString(nWins));
	ObjectSetText("Label LoseValue", IntegerToString(nLose));
	ObjectSetText("Label WinRateValue", DoubleToString(fPercentWin, 1) + "%");
	
   return(rates_total);
}


bool LabelCreate(const long		chart_ID=0,			// ID 
                 const string		name="Label",		//  
                 const int			x=0,					//    X
                 const int			y=0,					//    Y
                 const string		text="Label",		// 
                 const int			font_size = 15,	//  
                 const color		clr=clrLime)		// 
{
	ObjectCreate(chart_ID, name, OBJ_LABEL, 0, 0, 0);

	ObjectSetInteger(chart_ID,name, OBJPROP_XDISTANCE, x);
   ObjectSetInteger(chart_ID,name, OBJPROP_YDISTANCE, y);
   ObjectSetInteger(chart_ID,name, OBJPROP_CORNER, CORNER_RIGHT_UPPER);
   ObjectSetString (chart_ID,name, OBJPROP_TEXT, text);
   ObjectSetString (chart_ID,name, OBJPROP_FONT, "Arial");
   ObjectSetInteger(chart_ID,name, OBJPROP_FONTSIZE, font_size);
   ObjectSetInteger(chart_ID,name, OBJPROP_ANCHOR, ANCHOR_CENTER);
   ObjectSetInteger(chart_ID,name, OBJPROP_COLOR, clr);
   ObjectSetInteger(chart_ID,name, OBJPROP_BACK, false);
   
   return(true);
}

void CleanPoint(int nIndex, double &Buff1[], double &Buff2[])
{
   if(Buff2[nIndex] != EMPTY_VALUE && Buff2[nIndex + 1] != EMPTY_VALUE)
   {
      Buff2[nIndex + 1] = EMPTY_VALUE;
      return;
   }
   if(Buff1[nIndex] != EMPTY_VALUE && Buff1[nIndex + 1] != EMPTY_VALUE && Buff1[nIndex + 2] == EMPTY_VALUE)
   	Buff1[nIndex + 1] = EMPTY_VALUE;
}

void PlotPoint(int nIndex, double &Buff1[], double &Buff2[], double &Buff3[])
{
   if (Buff1[nIndex + 1] == EMPTY_VALUE)
   {
      if(Buff1[nIndex + 2] == EMPTY_VALUE)
      {
         Buff1[nIndex]		= Buff3[nIndex];
         Buff1[nIndex+1]	= Buff3[nIndex+1];
         Buff2[nIndex]		= EMPTY_VALUE;
         return;
      }
      
      Buff2[nIndex]		= Buff3[nIndex];
      Buff2[nIndex+1]	= Buff3[nIndex+1];
      Buff1[nIndex]	= EMPTY_VALUE;
      return;
   }
   
   Buff1[nIndex] = Buff3[nIndex];
   Buff2[nIndex] = EMPTY_VALUE;
}